require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_X86_64_PROCESSOR_H)) {
    eval 'sub __ASM_X86_64_PROCESSOR_H () {1;}' unless defined(&__ASM_X86_64_PROCESSOR_H);
    require 'asm/segment.ph';
    require 'asm/page.ph';
    require 'asm/types.ph';
    require 'asm/sigcontext.ph';
    require 'asm/cpufeature.ph';
    require 'linux/config.ph';
    require 'linux/threads.ph';
    require 'asm/msr.ph';
    require 'asm/current.ph';
    require 'asm/system.ph';
    require 'asm/mmsegment.ph';
    require 'linux/personality.ph';
    eval 'sub TF_MASK () {0x100;}' unless defined(&TF_MASK);
    eval 'sub IF_MASK () {0x200;}' unless defined(&IF_MASK);
    eval 'sub IOPL_MASK () {0x3000;}' unless defined(&IOPL_MASK);
    eval 'sub NT_MASK () {0x4000;}' unless defined(&NT_MASK);
    eval 'sub VM_MASK () {0x20000;}' unless defined(&VM_MASK);
    eval 'sub AC_MASK () {0x40000;}' unless defined(&AC_MASK);
    eval 'sub VIF_MASK () {0x80000;}' unless defined(&VIF_MASK);
    eval 'sub VIP_MASK () {0x100000;}' unless defined(&VIP_MASK);
    eval 'sub ID_MASK () {0x200000;}' unless defined(&ID_MASK);
    eval 'sub desc_empty {
        local($desc) = @_;
	    eval q((!(($desc)-> &a + ($desc)-> &b)));
    }' unless defined(&desc_empty);
    eval 'sub desc_equal {
        local($desc1, $desc2) = @_;
	    eval q(((($desc1)-> &a == ($desc2)-> &a)  && (($desc1)-> &b == ($desc2)-> &b)));
    }' unless defined(&desc_equal);
    eval 'sub current_text_addr () {
        eval q(({  &void * &pc;  &asm  &volatile(\\"leaq 1f(%%rip),%0\\\\n1:\\":\\"=r\\"( &pc));  &pc; }));
    }' unless defined(&current_text_addr);
    eval 'sub X86_VENDOR_INTEL () {0;}' unless defined(&X86_VENDOR_INTEL);
    eval 'sub X86_VENDOR_CYRIX () {1;}' unless defined(&X86_VENDOR_CYRIX);
    eval 'sub X86_VENDOR_AMD () {2;}' unless defined(&X86_VENDOR_AMD);
    eval 'sub X86_VENDOR_UMC () {3;}' unless defined(&X86_VENDOR_UMC);
    eval 'sub X86_VENDOR_NEXGEN () {4;}' unless defined(&X86_VENDOR_NEXGEN);
    eval 'sub X86_VENDOR_CENTAUR () {5;}' unless defined(&X86_VENDOR_CENTAUR);
    eval 'sub X86_VENDOR_RISE () {6;}' unless defined(&X86_VENDOR_RISE);
    eval 'sub X86_VENDOR_TRANSMETA () {7;}' unless defined(&X86_VENDOR_TRANSMETA);
    eval 'sub X86_VENDOR_NUM () {8;}' unless defined(&X86_VENDOR_NUM);
    eval 'sub X86_VENDOR_UNKNOWN () {0xff;}' unless defined(&X86_VENDOR_UNKNOWN);
    if(defined(&CONFIG_SMP)) {
	eval 'sub current_cpu_data () { $cpu_data[ &smp_processor_id()];}' unless defined(&current_cpu_data);
    } else {
	eval 'sub cpu_data () { &boot_cpu_data;}' unless defined(&cpu_data);
	eval 'sub current_cpu_data () { &boot_cpu_data;}' unless defined(&current_cpu_data);
    }
    eval 'sub X86_EFLAGS_CF () {0x1;}' unless defined(&X86_EFLAGS_CF);
    eval 'sub X86_EFLAGS_PF () {0x4;}' unless defined(&X86_EFLAGS_PF);
    eval 'sub X86_EFLAGS_AF () {0x10;}' unless defined(&X86_EFLAGS_AF);
    eval 'sub X86_EFLAGS_ZF () {0x40;}' unless defined(&X86_EFLAGS_ZF);
    eval 'sub X86_EFLAGS_SF () {0x80;}' unless defined(&X86_EFLAGS_SF);
    eval 'sub X86_EFLAGS_TF () {0x100;}' unless defined(&X86_EFLAGS_TF);
    eval 'sub X86_EFLAGS_IF () {0x200;}' unless defined(&X86_EFLAGS_IF);
    eval 'sub X86_EFLAGS_DF () {0x400;}' unless defined(&X86_EFLAGS_DF);
    eval 'sub X86_EFLAGS_OF () {0x800;}' unless defined(&X86_EFLAGS_OF);
    eval 'sub X86_EFLAGS_IOPL () {0x3000;}' unless defined(&X86_EFLAGS_IOPL);
    eval 'sub X86_EFLAGS_NT () {0x4000;}' unless defined(&X86_EFLAGS_NT);
    eval 'sub X86_EFLAGS_RF () {0x10000;}' unless defined(&X86_EFLAGS_RF);
    eval 'sub X86_EFLAGS_VM () {0x20000;}' unless defined(&X86_EFLAGS_VM);
    eval 'sub X86_EFLAGS_AC () {0x40000;}' unless defined(&X86_EFLAGS_AC);
    eval 'sub X86_EFLAGS_VIF () {0x80000;}' unless defined(&X86_EFLAGS_VIF);
    eval 'sub X86_EFLAGS_VIP () {0x100000;}' unless defined(&X86_EFLAGS_VIP);
    eval 'sub X86_EFLAGS_ID () {0x200000;}' unless defined(&X86_EFLAGS_ID);
    eval 'sub X86_CR4_VME () {0x1;}' unless defined(&X86_CR4_VME);
    eval 'sub X86_CR4_PVI () {0x2;}' unless defined(&X86_CR4_PVI);
    eval 'sub X86_CR4_TSD () {0x4;}' unless defined(&X86_CR4_TSD);
    eval 'sub X86_CR4_DE () {0x8;}' unless defined(&X86_CR4_DE);
    eval 'sub X86_CR4_PSE () {0x10;}' unless defined(&X86_CR4_PSE);
    eval 'sub X86_CR4_PAE () {0x20;}' unless defined(&X86_CR4_PAE);
    eval 'sub X86_CR4_MCE () {0x40;}' unless defined(&X86_CR4_MCE);
    eval 'sub X86_CR4_PGE () {0x80;}' unless defined(&X86_CR4_PGE);
    eval 'sub X86_CR4_PCE () {0x100;}' unless defined(&X86_CR4_PCE);
    eval 'sub X86_CR4_OSFXSR () {0x200;}' unless defined(&X86_CR4_OSFXSR);
    eval 'sub X86_CR4_OSXMMEXCPT () {0x400;}' unless defined(&X86_CR4_OSXMMEXCPT);
    eval 'sub MCA_bus () {0;}' unless defined(&MCA_bus);
    eval 'sub MCA_bus__is_a_macro () {1;}' unless defined(&MCA_bus__is_a_macro);
    eval 'sub TASK_SIZE () {(548682072064);}' unless defined(&TASK_SIZE);
    eval 'sub IA32_PAGE_OFFSET () {(( ($current->{personality}) &  &ADDR_LIMIT_3GB) ? 0xc0000000 : 0xffffe000);}' unless defined(&IA32_PAGE_OFFSET);
    eval 'sub TASK_UNMAPPED_32 () {( &IA32_PAGE_OFFSET / 3);}' unless defined(&TASK_UNMAPPED_32);
    eval 'sub TASK_UNMAPPED_64 () { &PAGE_ALIGN( &TASK_SIZE/3);}' unless defined(&TASK_UNMAPPED_64);
    eval 'sub TASK_UNMAPPED_BASE () {( &test_thread_flag( &TIF_IA32) ?  &TASK_UNMAPPED_32 :  &TASK_UNMAPPED_64);}' unless defined(&TASK_UNMAPPED_BASE);
    eval 'sub IO_BITMAP_BITS () {1024;}' unless defined(&IO_BITMAP_BITS);
    eval 'sub IO_BITMAP_BYTES () {( &IO_BITMAP_BITS/8);}' unless defined(&IO_BITMAP_BYTES);
    eval 'sub IO_BITMAP_LONGS () {( &IO_BITMAP_BYTES/$sizeof{\'long\'});}' unless defined(&IO_BITMAP_LONGS);
    eval 'sub IO_BITMAP_OFFSET () { &offsetof(1;}' unless defined(&IO_BITMAP_OFFSET);
    eval 'sub INVALID_IO_BITMAP_OFFSET () {0x8000;}' unless defined(&INVALID_IO_BITMAP_OFFSET);
    eval 'sub INIT_THREAD () {{};}' unless defined(&INIT_THREAD);
    eval 'sub INIT_MMAP () {{  &init_mm, 0, 0,  &NULL,  &PAGE_SHARED,  &VM_READ |  &VM_WRITE |  &VM_EXEC, 1,  &NULL,  &NULL };}' unless defined(&INIT_MMAP);
    eval 'sub STACKFAULT_STACK () {1;}' unless defined(&STACKFAULT_STACK);
    eval 'sub DOUBLEFAULT_STACK () {2;}' unless defined(&DOUBLEFAULT_STACK);
    eval 'sub NMI_STACK () {3;}' unless defined(&NMI_STACK);
    eval 'sub N_EXCEPTION_STACKS () {3;}' unless defined(&N_EXCEPTION_STACKS);
    eval 'sub EXCEPTION_STKSZ () {1024;}' unless defined(&EXCEPTION_STKSZ);
    eval 'sub EXCEPTION_STK_ORDER () {0;}' unless defined(&EXCEPTION_STK_ORDER);
    eval 'sub start_thread {
        local($regs,$new_rip,$new_rsp) = @_;
	    eval q( &do {  &asm  &volatile(\\"movl %0,%%fs; movl %0,%%es; movl %0,%%ds\\": :\\"r\\" (0));  &load_gs_index(0); ($regs)-> &rip = ($new_rip); ($regs)-> &rsp = ($new_rsp);  &write_pda( &oldrsp, ($new_rsp)); ($regs)-> &cs =  &__USER_CS; ($regs)-> &ss =  &__USER_DS; ($regs)-> &eflags = 0x200;  &set_fs( &USER_DS); }  &while(0));
    }' unless defined(&start_thread);
    eval 'sub thread_saved_pc {
        local($t) = @_;
	    eval q((*(($t)-> ($thread->{rsp}) - 8)));
    }' unless defined(&thread_saved_pc);
    eval 'sub KSTK_EIP {
        local($tsk) = @_;
	    eval q(((( ($tsk->{thread}->{rsp0}) - $sizeof{\'struct pt_regs\'}))-> &rip));
    }' unless defined(&KSTK_EIP);
    eval 'sub KSTK_ESP {
        local($tsk) = @_;
	    eval q(-1);
    }' unless defined(&KSTK_ESP);
1;
