require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SYSTEM_H)) {
    eval 'sub __ASM_SYSTEM_H () {1;}' unless defined(&__ASM_SYSTEM_H);
    require 'linux/config.ph';
    require 'linux/kernel.ph';
    require 'asm/segment.ph';
    if(defined(&__KERNEL__)) {
	if(defined(&CONFIG_SMP)) {
	    eval 'sub LOCK_PREFIX () {"lock ; ";}' unless defined(&LOCK_PREFIX);
	} else {
	    eval 'sub LOCK_PREFIX () {"";}' unless defined(&LOCK_PREFIX);
	}
	eval 'sub __STR {
	    local($x) = @_;
    	    eval q($x);
	}' unless defined(&__STR);
	eval 'sub STR {
	    local($x) = @_;
    	    eval q( &__STR($x));
	}' unless defined(&STR);
	eval 'sub __SAVE {
	    local($reg,$offset) = @_;
    	    eval q(\\"movq %%\\" $reg \\",(14-\\" $offset \\")*8(%%rsp)\\\\n\\\\t\\");
	}' unless defined(&__SAVE);
	eval 'sub __RESTORE {
	    local($reg,$offset) = @_;
    	    eval q(\\"movq (14-\\" $offset \\")*8(%%rsp),%%\\" $reg \\"\\\\n\\\\t\\");
	}' unless defined(&__RESTORE);
	if(defined(&CONFIG_X86_REMOTE_DEBUG)) {
	    eval 'sub SAVE_CONTEXT () {"pushfq\\n\\t" "subq $14*8,%%rsp\\n\\t"  &__SAVE( &rbx, 12)  &__SAVE( &rdi, 1)  &__SAVE( &rdx, 6)  &__SAVE( &rcx, 7)  &__SAVE( &r8, 8)  &__SAVE( &r9, 9)  &__SAVE( &r12, 2)  &__SAVE( &r13, 3)  &__SAVE( &r14, 4)  &__SAVE( &r15, 5)  &__SAVE( &r10, 10)  &__SAVE( &r11, 11)  &__SAVE( &rsi, 0)  &__SAVE( &rbp, 13);}' unless defined(&SAVE_CONTEXT);
	    eval 'sub RESTORE_CONTEXT () { &__RESTORE( &rbx, 12)  &__RESTORE( &rdi, 1)  &__RESTORE( &rdx, 6)  &__RESTORE( &rcx, 7)  &__RESTORE( &r12, 2)  &__RESTORE( &r13, 3)  &__RESTORE( &r14, 4)  &__RESTORE( &r15, 5)  &__RESTORE( &r10, 10)  &__RESTORE( &r11, 11)  &__RESTORE( &r8, 8)  &__RESTORE( &r9, 9)  &__RESTORE( &rbp, 13)  &__RESTORE( &rsi, 0) "addq $14*8,%%rsp\\n\\t" "popfq\\n\\t";}' unless defined(&RESTORE_CONTEXT);
	    eval 'sub __EXTRA_CLOBBER () {1;}' unless defined(&__EXTRA_CLOBBER);
	} else {
	    eval 'sub SAVE_CONTEXT () {"pushfq ; pushq %%rbp ; movq %%rsi,%%rbp\\n\\t";}' unless defined(&SAVE_CONTEXT);
	    eval 'sub RESTORE_CONTEXT () {"movq %%rbp,%%rsi ; popq %%rbp ; popfq\\n\\t";}' unless defined(&RESTORE_CONTEXT);
	    eval 'sub __EXTRA_CLOBBER () {,"rcx","rbx","rdx","r8","r9","r10","r11","r12","r13","r14","r15";}' unless defined(&__EXTRA_CLOBBER);
	}
	eval 'sub switch_to {
	    local($prev,$next,$last) = @_;
    	    eval q( &asm  &volatile( &SAVE_CONTEXT \\"movq %%rsp,%P[threadrsp](%[prev])\\\\n\\\\t\\" \\"movq %P[threadrsp](%[next]),%%rsp\\\\n\\\\t\\" \\"call __switch_to\\\\n\\\\t\\" \\".globl thread_return\\\\n\\" \\"thread_return:\\\\n\\\\t\\" \\"movq %%gs:%P[pda_pcurrent],%%rsi\\\\n\\\\t\\" \\"movq %P[thread_info](%%rsi),%%r8\\\\n\\\\t\\" \\"btr  %[tif_fork],%P[ti_flags](%%r8)\\\\n\\\\t\\" \\"movq %%rax,%%rdi\\\\n\\\\t\\" \\"jc   ret_from_fork\\\\n\\\\t\\"  &RESTORE_CONTEXT : \\"=a\\" ($last) : [$next] \\"S\\" ($next), [$prev] \\"D\\" ($prev), [ &threadrsp] \\"i\\" ( &offsetof(1;
	}' unless defined(&switch_to);
	eval 'sub loadsegment {
	    local($seg,$value) = @_;
    	    eval q( &asm  &volatile(\\"\\\\n\\" \\"1:\\\\t\\" \\"movl %k0,%%\\" $seg \\"\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:\\\\t\\" \\"movl %1,%%\\" $seg \\"\\\\n\\\\t\\" \\"jmp 2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\\\t\\" \\".align 8\\\\n\\\\t\\" \\".quad 1b,3b\\\\n\\" \\".previous\\" : :\\"r\\" ($value), \\"r\\" (0)));
	}' unless defined(&loadsegment);
	eval 'sub set_debug {
	    local($value,$register) = @_;
    	    eval q( &__asm__(\\"movq %0,%%db\\" $register : :\\"r\\" ( $value)));
	}' unless defined(&set_debug);
	if(defined(&__KERNEL__)) {
	}
	eval 'sub clts () {
	    eval q( &__asm__  &__volatile__ (\\"clts\\"));
	}' unless defined(&clts);
	eval 'sub stts () {
	    eval q( &write_cr0(8|  &read_cr0()));
	}' unless defined(&stts);
	eval 'sub wbinvd () {
	    eval q( &__asm__  &__volatile__ (\\"wbinvd\\": : :\\"memory\\"););
	}' unless defined(&wbinvd);
    }
    eval 'sub nop () {
        eval q( &__asm__  &__volatile__ (\\"nop\\"));
    }' unless defined(&nop);
    eval 'sub xchg {
        local($ptr,$v) = @_;
	    eval q((( &__typeof__(*)) &__xchg(($v),($ptr),$sizeof{($ptr)})));
    }' unless defined(&xchg);
    eval 'sub tas {
        local($ptr) = @_;
	    eval q(( &xchg(($ptr),1)));
    }' unless defined(&tas);
    eval 'sub __xg {
        local($x) = @_;
	    eval q((($x)));
    }' unless defined(&__xg);
1;
